<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\Core\Product\Models;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
   const SERVICE = 1;
   const PHYSICAL = 0;
   const NORMAL = 1;
   const COMPOSITION = 2;
   const ACTIVE = 1;
   const INACTIVE = 0;
   const CREATED_AT = 'pro_date_insert';
   const UPDATED_AT = 'pro_date_update';
   const CREATED_BY = 'pro_user_insert';
   const UPDATED_BY = 'pro_user_update';
   protected $connection = 'dynamicdb';
   protected $table = 'produto.produto';
   protected $primaryKey = "pro_codigo";
   protected $fillable = [
      "pro_descricao",
      "pro_fk_prs_codigo",
      "pro_titulo",
      "pro_date_insert",
      "pro_user_update",
      "pro_date_update",
      "pro_user_insert",
      "pro_codigo",
      "pro_status",
      "pro_fk_cla_codigo",
      "pro_fk_pcg_codigo_cred",
      "pro_fk_pcg_codigo_deb",
      "pro_fk_mar_codigo",
      "pro_fk_ncm_codigo",
      "pro_cest",
      "pro_servico",
      "pro_controla_serial",
      "pro_codigo_servico_municipio",
      "pro_catalogo",
      "pro_cnae",
      "pro_servico_isento_iss",
      "pro_tipo",
      "pro_escala_relevante",
      "pro_descricao_publica"
   ];
   protected $casts = [
      'pro_servico' => 'string',
      'pro_controla_serial' => 'string',
      'pro_status' => 'string',
      'pro_fk_prs_codigo' => 'string',
      'pro_fk_mar_codigo' => 'string',
   ];


   public function product_variety()
   {
      return $this->hasMany(ProductVariety::class, 'prv_fk_pro_codigo')->with('product_variety_pack');
   }
//
   public function classification(){
       return $this->belongsTo(Classification::class, 'pro_fk_cla_codigo');
   }

   public function product_product_setup_attribute(){
      return $this->hasMany(ProductProductSetupAttribute::class, 'ppsa_fk_pro_codigo')->with('product_setup_attribute');
   }
}
